--
-- @Autor: WarezLine
-- @Version 1.0.0

print("============================")
print("==     Multi cheat v1     ==")
print("============================")
source(Utils.getFilename("scripts/MC_Carga.lua", g_currentModDirectory))

--- Multi cheat Silos
MultiCheat = {
	obj={},
	iKeySilo=nil,
	iKeyAnim=nil,
	iKeyMoney=nil
};

addModEventListener(MultiCheat);

-- Verifica la visibilidad de los menus.
function MultiCheat:update(dt)
	MultiCheat.iKeySilo = nil
	MultiCheat.iKeyAnim = nil
	MultiCheat.iKeyMoney = nil
	local px,py,pz = getWorldTranslation(g_currentMission.player.rootNode)
	for index, obj in pairs(MultiCheat.obj) do
		local ox,oy,oz = getWorldTranslation(obj.id)
		local dist = MathUtil.vector3Length(px-ox,py-oy,pz-oz)
		if dist < obj.dist and obj.tipo == 1 then
			MultiCheat.iKeySilo=index;
		elseif dist < obj.dist and obj.tipo == 2 then
			MultiCheat.iKeyAnim=index;
		end
		if dist < obj.dist then
			MultiCheat.iKeyMoney=index;
		end
		--renderText(0.30,0.95 - (index*0.025),0.02,tostring(dist))
	end
	MultiCheat:Menu();
end

-- Agrega los objetos al controlador.
Placeable.finalizePlacement = Utils.prependedFunction(Placeable.finalizePlacement, function(self)
	if self.className == "SiloPlaceable" and #self.levelAreas > 0 then
		table.insert(MultiCheat.obj, {tipo=1, dist=10, obj=self.storages[1], id=self.unloadingStation.unloadTriggers[1].exactFillRootNode,del=self.nodeId} );
	elseif self.className == "AnimalHusbandry" and self.modulesByName.animals.animalType ~= "DOG" then
		table.insert(MultiCheat.obj, {tipo=2, dist=5, obj=self, id=self.modulesById[1].animalLoadingTrigger.triggerNode,del=self.nodeId} );
	elseif self.className == "Workshop" or self.className == "BuyingStationPlaceable" or self.className == "SellingStationPlaceable" then
		table.insert(MultiCheat.obj, {tipo=3, dist=5, obj=self, id=self.nodeId,del=self.nodeId} );
	end;
end);

-- Eliminar los objetos del controlador.
Placeable.delete = Utils.prependedFunction(Placeable.delete, function(self)
	if self.className == "SiloPlaceable" or self.className == "AnimalHusbandry" or self.className == "SellingStationPlaceable" or self.className == "Workshop" or self.className == "BuyingStationPlaceable" then
		for index, obj in pairs(MultiCheat.obj) do
			if obj.del == self.nodeId then
				table.remove(MultiCheat.obj, index);
			end
		end
	end;
end);

-- Registra los menus
function MultiCheat:registerActionEvents()
	_, MultiCheat[InputAction.KEYSILO] = g_inputBinding:registerActionEvent(InputAction.KEYSILO, self, MultiCheat.Action ,false ,true ,false ,true) 
	_, MultiCheat[InputAction.KEYANIM] = g_inputBinding:registerActionEvent(InputAction.KEYANIM, self, MultiCheat.Action ,false ,true ,false ,true)
	_, MultiCheat[InputAction.KEYMONEY] = g_inputBinding:registerActionEvent(InputAction.KEYMONEY, self, MultiCheat.Action ,false ,true ,false ,true)
	MultiCheat:Menu();
end
BaseMission.registerActionEvents = Utils.appendedFunction(BaseMission.registerActionEvents , MultiCheat.registerActionEvents);

-- Muestra o culta los menu.
function MultiCheat:Menu()
	-- Menu de los silos
	g_inputBinding:setActionEventTextVisibility(MultiCheat[InputAction.KEYSILO], MultiCheat.iKeySilo ~= nil)
	g_inputBinding:setActionEventActive(MultiCheat[InputAction.KEYSILO], MultiCheat.iKeySilo ~= nil)
	g_inputBinding:setActionEventTextPriority(MultiCheat[InputAction.KEYSILO], 2);
	-- Menu de los corrales.
	g_inputBinding:setActionEventTextVisibility(MultiCheat[InputAction.KEYANIM], MultiCheat.iKeyAnim ~= nil)
	g_inputBinding:setActionEventActive(MultiCheat[InputAction.KEYANIM], MultiCheat.iKeyAnim ~= nil)
	g_inputBinding:setActionEventTextPriority(MultiCheat[InputAction.KEYANIM], 2);
	-- Menu de los cajeros.
	g_inputBinding:setActionEventTextVisibility(MultiCheat[InputAction.KEYMONEY], MultiCheat.iKeyMoney ~= nil)
	g_inputBinding:setActionEventActive(MultiCheat[InputAction.KEYMONEY], MultiCheat.iKeyMoney ~= nil)
	g_inputBinding:setActionEventTextPriority(MultiCheat[InputAction.KEYMONEY], 2);
end

-- Accion segun el menu utilizado.
function MultiCheat:Action (actionName, keyStatus)
	-- Rellenar silo.
	if actionName == InputAction.KEYSILO and MultiCheat.iKeySilo ~= nil then
		local obj = MultiCheat.obj[MultiCheat.iKeySilo].obj;
		for filtype, _ in pairs(obj.fillTypes) do
			obj.fillLevels[filtype] = obj.capacityPerFillType;
		end
	end
	-- Mantenimiento de animales.
	if actionName == InputAction.KEYANIM and MultiCheat.iKeyAnim ~= nil  then
		local obj = MultiCheat.obj[MultiCheat.iKeyAnim].obj;
		if obj.modulesByName.animals.owner.ownerFarmId == g_currentMission.player.farmId then
			for _, objH in pairs(obj.modulesById) do
				for index,_ in pairs(objH.fillLevels) do
					objH.fillLevels[index] = objH:getCapacity();
				end
				if objH.cleanlinessFactor ~= nil then
					objH.cleanlinessFactor = 1.0
					obj:setModuleParameters("foodSpillage", 0, 0) -- setCapacity, setSingleAnimalUsagePerDay
				end
				if objH.animalType ~= nil and objH.animalType == "HORSE" then
					for _, caballo in pairs(objH.animals) do
						caballo.ridingTimer = (caballo.ridingTimer + caballo.DAILY_TARGET_RIDING_TIME)
						caballo.ridingTimerSent = (caballo.ridingTimer + caballo.DAILY_TARGET_RIDING_TIME)
					end
				end
			end
		end
	end
	-- Agregar dinero
	if actionName == InputAction.KEYMONEY and MultiCheat.iKeyMoney ~= nil then
		g_currentMission.landscapingController.playerFarm.money = g_currentMission.landscapingController.playerFarm.money + 1000000.0;
	end
end

-- capacidad de carga del remolque o vehiculo
local specname = "MC_Carga"
if g_specializationManager:getSpecializationByName(specname) == nil then
	g_specializationManager:addSpecialization(specname, specname, Utils.getFilename("scripts/MC_Carga.lua", g_currentModDirectory), true, nil);
	for vhtype, vh in pairs(g_vehicleTypeManager.vehicleTypes) do
		if vh.specializationsByName.fillUnit ~= nil then
			g_vehicleTypeManager:addSpecialization(vhtype, specname)
		end
	end
end